/**
* Copyright (c) 2018 The Nuinalp Authors. All rights reserved.
* Use of this source code is governed by a BSD-style license that can be
* found in the LICENSE file.
*/

@import '../../style/utils/animations';
@import '../../style/utils/flex';
@import '../../style/utils/display';
@import '../../style/utils/sizes';
@import '../../style/utils/spacing';

.nv-date-picker {
  cursor: pointer;
  display: inline-block;
  height: 52px;
  position: relative;

  .date-picker {
    background-color: var(--nv-theme-alt-2);
    border-bottom-color: var(--nv-border-color);
    border-bottom-style: solid;
    border-bottom-width: 2px;
    border-radius: 8px;
    box-sizing: border-box;
    cursor: pointer;
    display: inline-block;
    height: 52px;
    min-width: 150px;
    padding: $space-default;
    position: relative;
    transform: scale(1);
    transition-property: boder-color, transform, opacity;
    
    * {
      pointer-events: none;
    }
  
    &:hover {
      border-color: var(--nv-theme-primary);
    }
  }

  .nv-date-picker-icon {
    bottom: $space-default;
    height: $space-sm;
    position: absolute;
    right: $space-default;
    width: $space-sm;

    path {
      fill: var(--nv-theme-primary);
    }
  }


  //
  // Label
  //

  .nv-date-picker,
  .nv-date-picker-selected-value {
    display: block;
    overflow: hidden;
    padding-right: 16px;
    pointer-events: none;
    text-overflow: ellipsis;
    white-space: nowrap;
    width: 100%;
  }

  .nv-date-picker-selected-value {
    transform: translateY(8px);
  }

  .nv-date-picker-label {
    color: var(--nv-type-secondary);
    font-family: 'FiraGO Italic';
  }

  .nv-date-picker-label-active {
    font-size: 12px;
    height: inherit;
    left: 0 !important;
    padding: calc(#{$space-sm} - 4px) #{$space-default};
    pointer-events: none;
    position: absolute;
    top: 0;
    transform: translateY(0%);
  }

  //
  // Opened
  //

  &.opened {
    .date-picker {
      z-index: 1;
    }

    .calendar {
      @extend .transition-entrance;
      opacity: 1;
      transform: translateY(0%);
      transition-delay: 0ms, 0s;
      transition-property: opacity, transform;
      visibility: visible;
    }
  }

  //
  // Disabled
  //

  &.nv-date-picker-disabled {
    cursor: default;
    opacity: 0.55;

    &:hover {
      .nv-date-picker-el {
        border-color: var(--nv-border-color);
      }
    }
  }

  //
  // Naked style
  //
  
  &.nv-date-picker-naked {
    .nv-date-picker-el {
      background-color: transparent !important;
      border-color: transparent;
    }
  }
}


.calendar {
  @extend .transition-exit;
  background-color: var(--nv-theme-alt-2);
  border-bottom-color: var(--nv-border-color);
  border-bottom-style: solid;
  border-bottom-width: 2px;
  border-radius: 8px;
  box-sizing: border-box;
  cursor: default;
  display: none;
  left: 0;
  margin-top: $space-sm;
  min-width: 265px;
  opacity: 0;
  padding: $space-default;
  position: absolute;
  top: 100%;
  transform: translateY(-10%);
  transition-delay: 0ms, 100ms;
  transition-property: opacity, transform;
  visibility: hidden;
  z-index: 10;

  &.display {
    display: inline-block;
  }
  
  td,
  tr {
    box-sizing: border-box;
    height: 30px;
    max-width: 30px;
    min-width: 30px;
    width: 30px;

    > div {
      align-items: center;
      display: flex;
      justify-content: center;
      position: relative;
      vertical-align: middle;
      z-index: 1;
    }
  }
}

.calendar-day {
  &:hover > div {
    @extend .transition-entrance;
    opacity: 1;
    transition-property: opacity;
  }
}

.calendar-title {
  @extend .transition-exit;
  border-radius: 8px;
  cursor: pointer;
  display: block;
  font-family: 'FiraGO Bold Italic';
  padding: $space-sm;
  transition-property: background-color;

  &:hover {
    background-color: var(--nv-theme-alt-1);
  }
}

.not-current-month {
  > div {
    opacity: 0.55;
  }
}

.day-name,
.calendar-month,
.calendar-title {
  text-transform: capitalize;
}

.calendar-day,
.calendar-month {
  cursor: pointer;
  position: relative;
  user-select: none;

  &::before {
    background-color: var(--nv-theme-alt-1);
    border-radius: 50%;
    content: '';
    height: 30px;
    left: 0;
    opacity: 0;
    position: absolute;
    top: 0;
    visibility: hidden;
    width: 30px;
    z-index: 0;
  }

  > div {
    z-index: 1;
  }

  &:hover::before {
    opacity: 1;
    transition-property: opacity, visibility;
    visibility: visible;
  }
}

.calendar-day.selected-day,
.calendar-month.selected-month {
  color: var(--nv-type-primary-light);
  
  &::before {
    background-color: var(--nv-theme-primary) !important;
    opacity: 1;
    visibility: unset;
  }
}

.calendar-month {
  height: 40px !important;
  max-width: 40px !important;
  min-width: 40px !important;
  user-select: none;
  width: 40px !important;
  
  &::before {
    border-radius: 8px !important;
    height: 100%;
    width: 100%;
  }
}

//
// Navigation buttons
//

.nav-btns {
  // @extend .transition-moviment;
  border-radius: 50%;
  box-sizing: border-box;
  cursor: pointer;
  height: 40px;
  padding: $space-sm;
  user-select: none;
  width: 40px;
  
  &:hover {
    background-color: var(--nv-theme-alt-1);
  }
}

table {
  table-layout: fixed;
}
